-- name: [CS] Jenny
-- description: Jenny from My Life as a Teenage Robot
--[[API Documentation for Character Select can be found below:
https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation]]

--- MODEL ---
local E_MODEL_JENNY = smlua_model_util_get_id("jenny_geo")

--- ICON ---
local TEX_ICON_JENNY = get_texture_info("jenny-icon")

--- VOICE ---
local CUSTOM_VOICETABLE_JENNY = {
    [CHAR_SOUND_OKEY_DOKEY] =        'JennyStartGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'JennyStartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'JennyPunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'JennyPunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'JennyPunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'JennyJump1.ogg', 'JennyJump2.ogg', 'JennyJump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'JennyDoubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'JennyTripleJump1.ogg', 'JennyTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'JennyBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'JennyLongJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'JennyLongJumpLand2.ogg',
	[CHAR_SOUND_HAHA] =              'JennyTripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'JennyLongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'JennyLongJumpBonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'JennyGrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'JennyClimbLedge.ogg', -- Climbing over ledge
	[CHAR_SOUND_WAAAOOOW] =          'JennyFalling.ogg', -- Falling a long distance
	[CHAR_SOUND_TWIRL_BOUNCE] =      'JennyFlowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'JennyGroundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'JennyLift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'JennyGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'JennyThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'JennyDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'JennyPanting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'JennyBurned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'JennyTired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'JennyYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'JennySnore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'JennyExhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'JennySleepTalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'JennyCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'JennyCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'JennyCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'JennyDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'JennyDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'JennyLeaveLevel.ogg' -- Booted out of level
}

--- CHARACTER ---
if _G.charSelectExists then
    -- Add the main character
    local jenny_id = _G.charSelect.character_add(
        "Jenny",
        {"My teenage robot... life!", " "},
        "TheEnderDwonk",
        {r = 40, g = 203, b = 217},
        E_MODEL_JENNY,
        CT_LUIGI,
        TEX_ICON_JENNY
    )


    -- Add custom voice
    _G.charSelect.character_add_voice(E_MODEL_JENNY, CUSTOM_VOICETABLE_JENNY)

    -- Hook events for the character's custom behavior
    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_JENNY then
            return _G.charSelect.voice.sound(m, sound)
        end
    end)

    hook_event(HOOK_MARIO_UPDATE, function(m)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_JENNY then
            return _G.charSelect.voice.snore(m)
        end
    end)
end
